; Assembly Source File
; Created 6/18/02, 8:04:04 PM

	include	"os.h"
	xdef	_main
	xdef	_ti89
	xdef	_nostub
_main:
	lea	-2992(sp),sp		;save screen data to the stack
	move.l	#$4C00,a0
	move.l	#747,d0
	move.l	#$00000001,d6
copyloop:
	move.l	(a0),(sp)+
	clr.l	(a0)+
	dbra.w	d0,copyloop
	clr.l	d5			;set counter to zero
	move.l	#$0700,d0		;setup interrupt sequence
	trap	#1
	move.l	($64),oldint
	bclr.b	#2,($600001)
	move.l	#newint,($64)
	bset.b	#2,($600001)
	trap	#1
	bra	disp
newint:					;keycheck
	move.w	#$FFFE,($600018)
	move.l	#30,d4
delay:
	dbra.w	d4,delay
	move.w	($60001A),d4
	cmpi.b	#$FE,d4
	beq	setinc
	cmpi.b	#$FB,d4
	beq	setdec
	cmpi.b	#$BF,d4
	beq	pause
	cmpi.b	#$EF,d4
	bne	done
	clr.l	d6
done:
	rte
pause:
	clr.b	d4
	rte
setinc:
	move.l	#$00000001,d6
	rte
setdec:
	move.l	#$FFFFFFFF,d6
	rte
inc:
	add.l	d6,d5
incloop:
	tst.b	d4
	beq	incloop
disp:
	move.l	#$FFFFFFFF,d1
	lea	datad2(pc),a3		;load the address of the powers of ten
	move.l	(a3)+,d2		;load the power of 10 into d2
	move.l	d5,d0			;make a copy of the number
	move.l	d1,d3
disploop:
	addq.l	#1,d1
	sub.l	d2,d0			;subtract a power of 10 until the number is as small as possible, and we know that the number of times we subtract the power of 10 will be a digit of the base ten number
	bcc	disploop
	addq.l	#1,d3
	add.l	d2,d0
	move.l	#$4C00,a2
	add.l	d3,a2			;move the location of the displayed digit
	rol.l	#3,d1
	lea	sprite0(pc),a1
	add.l	d1,a1			;select which digit to display
	bsr	drawaligned		;draw the digit
	cmp.l	#1,d2
	beq	disphex			;display the hex equivalent of the base ten number
	move.l	(a3)+,d2
	move.l	#$FFFFFFFF,d1
	tst.l	d6
	bne	disploop
realquit:
	move.l	#$0700,d0		;restore the old interrupts
	trap	#1
	bclr.b	#2,($600001)
	move.l	(oldint),($64)
	bset.b	#2,($600001)
	trap	#1
	lea	-2992(sp),sp
	move.l	#$4C00,a0
	move.l	#747,d0
copyloop2:				;restore the screen
	move.l	(sp)+,(a0)+
	dbra.w	d0,copyloop2
	rts
disphex:
	move.l	#$FFFFFFFF,d1
	move.l	#7,d3
	move.l	#7,d2
hexloop:
	move.l	d5,d0
	addq.l	#1,d1
shiftloop:
	subq.l	#1,d2
	bcs	nexthex
	lsr.l	#4,d0
	bra	shiftloop
nexthex:
	lea	sprite0(pc),a1
	andi.l	#$F,d0
	lsl.l	#3,d0
	add.l	d0,a1
	move.l	#$4DE0,a2
	add.l	d1,a2
	bsr	drawaligned
	cmpi.l	#7,d1
	beq	inc
	subq.l	#1,d3
	move.l	d3,d2
	bra	hexloop
drawaligned:
	move.l	#7,d7
spriteloop:
	move.b	(a1)+,(a2)
	lea	30(a2),a2
	dbra.w	d7,spriteloop
	rts
oldint:
	dc.l	0
datad2:
	dc.l	1000000000		;how many times does 10^9 go into the number
	dc.l	100000000		;		     10^8
	dc.l	10000000		;10^7
	dc.l	1000000			;10^6
	dc.l	100000			;10^5
	dc.l	10000			;10^4
	dc.l	1000			;10^3
	dc.l	100			;10^2
	dc.l	10			;10^1
	dc.l	1			;10^0
sprite0:
	dc.b	%01111100
	dc.b	%10000110
	dc.b	%10001010
	dc.b	%10010010
	dc.b	%10010010
	dc.b	%10100010
	dc.b	%11000010
	dc.b	%01111100
sprite1:
	dc.b	%00001000
	dc.b	%00011000
	dc.b	%00001000
	dc.b	%00001000
	dc.b	%00001000
	dc.b	%00001000
	dc.b	%00001000
	dc.b	%00011100
sprite2:
	dc.b	%01111100
	dc.b	%10000010
	dc.b	%00000010
	dc.b	%00000010
	dc.b	%00001100
	dc.b	%00110000
	dc.b	%01000000
	dc.b	%11111110
sprite3:
	dc.b	%11111100
	dc.b	%00000010
	dc.b	%00000010
	dc.b	%01111100
	dc.b	%00000010
	dc.b	%00000010
	dc.b	%00000010
	dc.b	%11111100
sprite4:
	dc.b	%10000100
	dc.b	%10000100
	dc.b	%10000100
	dc.b	%10000100
	dc.b	%11111110
	dc.b	%00000100
	dc.b	%00000100
	dc.b	%00000100
sprite5:
	dc.b	%11111100
	dc.b	%10000000
	dc.b	%10000000
	dc.b	%11111100
	dc.b	%00000010
	dc.b	%00000010
	dc.b	%00000010
	dc.b	%11111100
sprite6:
	dc.b	%01111100
	dc.b	%10000010
	dc.b	%10000000
	dc.b	%11111100
	dc.b	%10000010
	dc.b	%10000010
	dc.b	%10000010
	dc.b	%01111100
sprite7:
	dc.b	%01111110
	dc.b	%00000010
	dc.b	%00000100
	dc.b	%00000100
	dc.b	%00001000
	dc.b	%00001000
	dc.b	%00010000
	dc.b	%00010000
sprite8:
	dc.b	%01111100
	dc.b	%10000010
	dc.b	%10000010
	dc.b	%01111100
	dc.b	%10000010
	dc.b	%10000010
	dc.b	%10000010
	dc.b	%01111100
sprite9:
	dc.b	%01111100
	dc.b	%10000010
	dc.b	%10000010
	dc.b	%10000010
	dc.b	%01111110
	dc.b	%00000010
	dc.b	%00000010
	dc.b	%01111100
spriteA:
	dc.b	%01111100
	dc.b	%10000010
	dc.b	%10000010
	dc.b	%10000010
	dc.b	%11111110
	dc.b	%10000010
	dc.b	%10000010
	dc.b	%10000010
spriteB:
	dc.b	%11111100
	dc.b	%10000010
	dc.b	%10000010
	dc.b	%11111100
	dc.b	%10000010
	dc.b	%10000010
	dc.b	%10000010
	dc.b	%11111100
spriteC:
	dc.b	%01111100
	dc.b	%10000010
	dc.b	%10000000
	dc.b	%10000000
	dc.b	%10000000
	dc.b	%10000000
	dc.b	%10000010
	dc.b	%01111100
spriteD:
	dc.b	%11111100
	dc.b	%10000010
	dc.b	%10000010
	dc.b	%10000010
	dc.b	%10000100
	dc.b	%10001000
	dc.b	%10010000
	dc.b	%11100000
spriteE:
	dc.b	%01111110
	dc.b	%10000000
	dc.b	%10000000
	dc.b	%01111110
	dc.b	%10000000
	dc.b	%10000000
	dc.b	%10000000
	dc.b	%01111110
spriteF:
	dc.b	%01111110
	dc.b	%10000000
	dc.b	%10000000
	dc.b	%10000000
	dc.b	%11111000
	dc.b	%10000000
	dc.b	%10000000
	dc.b	%10000000	
	
	end